//******************************************************************************
// TotalToolbar functions.
//******************************************************************************

/* Initialization function */
function tt_init() {
//  window.removeEventListener("load", tt_init, false);

debugTT("init");
//  if (document.documentElement.getAttribute("windowtype") != "navigator:browser")
//    return;

  BrowserCustomizeToolbar = function BrowserCustomizeToolbar() {
    // Disable the toolbar context menu items
    var menubar = document.getElementById("main-menubar");
    for (var i = 0; i < menubar.childNodes.length; ++i)
      menubar.childNodes[i].setAttribute("disabled", true);

    var cmd = document.getElementById("cmd_CustomizeToolbars");
    cmd.setAttribute("disabled", "true");

    var splitter = document.getElementById("urlbar-search-splitter");
    if (splitter)
      splitter.parentNode.removeChild(splitter);

    var menu = document.getElementById("tt-toolbar-properties");
    if (menu)
      menu.setAttribute("disabled", true);

    CombinedStopReload.uninit();

    PlacesToolbarHelper.customizeStart();
    BookmarksMenuButton.customizeStart();

    var customizeURL = "chrome://global/content/customizeToolbar.xul";
    var customizeTab = gBrowser.addTab(customizeURL,
                                       {ownerTab: gBrowser.selectedTab});
    gBrowser.moveTabTo(customizeTab, gBrowser.selectedTab._tPos + 1);
    gBrowser.selectedTab = customizeTab;
//    switchToTabHavingURI(customizeURL, true);
//    gBrowser.selectedTab = gBrowser.addTab(customizeURL,
//                                           {ownerTab: gBrowser.selectedTab});
    gBrowser.selectedTab.setAttribute("customizeToolbarInTab", true);
  }

  var fx_BrowserFullScreen = BrowserFullScreen;
  BrowserFullScreen = function BrowserFullScreen() {
    fx_BrowserFullScreen();
    tt_BrowserFullScreen();
  }

  var fx_BrowserToolboxCustomizeDone = BrowserToolboxCustomizeDone;
  gNavToolbox.customizeDone = function BrowserToolboxCustomizeDone() {
debugTT("start");
//return;
    fx_BrowserToolboxCustomizeDone();

    document.getElementById("tt-toolbar-properties").removeAttribute("disabled");
//    var customizeTab = gBrowser.selectedTab;
//    gBrowser.selectedTab = customizeTab.owner; //
//    gBrowser.selectTabAtIndex(0); //addTab(customizeURL);
//    try {
//closeWindow(false);
//    gBrowser.removeTab(customizeTab, {animate: true});
//    } catch(e) {};
debugTT("removed tab");
    tt_adjustToolboxWidth(true);
  }

  tt_setTabsToolbar();

  // Label der Toolbareinstellungen tauschen, wenn der Browser im RTL-Modus ist
  // (Sidebar rechts).
  let str_left = document.getElementById("tt-left").getAttribute("label");
  let str_sidebarleft = document.getElementById("tt-sidebarleft").getAttribute("label");
  let str_right = document.getElementById("tt-right").getAttribute("label");
  try {
    let wStyle = document.defaultView.
                          getComputedStyle(document.getElementById("browser"), "");
    if (wStyle.direction == "rtl") {
      document.getElementById("tt-left").setAttribute("label", str_right);
      document.getElementById("tt-sidebarright").setAttribute("label", str_sidebarleft);
      document.getElementById("tt-right").setAttribute("label", str_left);
    }
  }
  catch (e) { }

  tt_adjustToolboxWidth(true);
}

//window.addEventListener("load", tt_init, false);
/* Initialize */
setTimeout(function() { tt_init() }, 1000);


function tt_setTabsToolbar(aToolboxId) {
  let toolbar = document.getElementById("TabsToolbar");
  let ownertoolboxId = toolbar.getAttribute("ownertoolbox");
  let toolboxId = aToolboxId ? aToolboxId : ownertoolboxId ? ownertoolboxId :
                                                             gNavToolbox.id;
//debugTT("tt_setTabsToolbar: toolboxId - "+toolboxId);
  if (toolbar.parentNode.id == toolboxId)
    return;

  let newToolbox = document.getElementById(toolboxId);
  let tabs = document.getElementById("tabbrowser-tabs");
  newToolbox.insertBefore(toolbar, newToolbox.lastChild);
  // Need to set the attribute, css doesn't work.
  // Note: vertical tabs positioning (contextmenu options) removed for now.
  if (newToolbox.hasAttribute("vertical")) {
    tabs.setAttribute("orient", "vertical");
    tabs.removeAttribute("flex");
    tabs.mTabstrip.setAttribute("orient", "vertical");
  }
  else {
    tabs.setAttribute("orient", "horizontal");
    tabs.setAttribute("flex", "1");
  }

  toolbar.setAttribute("ownertoolbox", newToolbox.id);
  document.persist(toolbar.id, "ownertoolbox");

  if (newToolbox.id == gNavToolbox.id) {
    if (TabsOnTop.enabled) {
      TabsOnTop.enabled = false;
      setTimeout(function() { TabsOnTop.toggle() }, 0);
    }
    else
      document.getElementById("main-window").removeAttribute("tabsontop");

    // Remove tabs toolbar from external toolbar, if there.
    let newExternalToolbars = [];
    toolbar.removeAttribute("toolboxid");
    gNavToolbox.externalToolbars.forEach(function (extToolbar, index) {
      if (extToolbar.id != toolbar.id)
        newExternalToolbars.push(extToolbar);
    })
    gNavToolbox.externalToolbars = newExternalToolbars;
  }
  else {
    // New toolbox is not 'Top' location.  So if TabsOnTop is checked, and they
    // aren't there, the App Button will overflow due to it's (rather poor) css
    // relative pos design.  So we remove the tabsontop attribute to avoid this
    // css rule.  Note that the checkbox will remain checked so if tabs are moved
    // back to 'Top' it will behave as where the user last left the selection.
    document.getElementById("main-window").removeAttribute("tabsontop");

    // Add to external toolbars list for customization.
    gNavToolbox.externalToolbars.push(toolbar);
  }

  // Moved tabs toolbar; first tab title needs to be restored (4.0b8pre).
  let tab = gBrowser.tabs[0];
  tab.label = tab.linkedBrowser.contentTitle;
}

/* For vertical tabs width adjustment only */
function tt_onTabsToolbarKeyPress(aEvent) {
  let node = aEvent.target;
  while (node.localName != "toolbar")
    node = node.parentNode;

  if (!node || node.id != "TabsToolbar" ||
      node.parentNode.getAttribute("vertical") != "true")
    return;

  if (!(aEvent.shiftKey &&
        (aEvent.keyCode == aEvent.DOM_VK_RIGHT ||
         aEvent.keyCode == aEvent.DOM_VK_LEFT)))
    return;

  let width = parseInt(node.getAttribute("width"));
  let wider = aEvent.keyCode == aEvent.DOM_VK_RIGHT ? true : false;
  let newWidth = wider ? ++width : --width;
  node.setAttribute("width", newWidth);
}

/* Set up toolbar context menu */
function tt_initCustomiseContext(evt, popup) {

  let toolbar = document.popupNode; //evt.target;
//debugTT("toolbar.id: "+toolbar.id);
  if (!toolbar)
    return;
  while (toolbar.localName != "toolbar")
    toolbar = toolbar.parentNode;

  let isTabsToolbar = toolbar.id == "TabsToolbar";
  let isFixedToolbar = ["toolbar-menubar", "nav-bar",
                        "PersonalToolbar", "addon-bar"].indexOf(toolbar.id) != -1;
  let isCustomizableToolbar = toolbar.getAttribute("customizable") == "true" ? true : false;
  let isFixedToolbox = toolbar.parentNode.classList.contains("tt-toolbox-fixed");
  let child;

  // Einstellungen.
  let mode = toolbar.getAttribute("mode");
  let lockmode = toolbar.getAttribute("lockmode") == "true" ? true : false;
  let small = toolbar.getAttribute("iconsize") == "small";
  let lockiconsize = toolbar.getAttribute("lockiconsize") == "true" ? true : false;
  let flexbuttons = toolbar.hasAttribute("flexbuttons");
  let fullscreentoolbar = toolbar.hasAttribute("fullscreentoolbar");
  let position = toolbar.parentNode.getAttribute("id");

  for (let i = 0; i < popup.childNodes.length; i++) {
    child = popup.childNodes[i];

    // M O D E
    if (child.getAttribute("name") == "mode") {
      child.setAttribute("checked", child.getAttribute("value") == mode);
      child.disabled = lockmode;
    }
    // S M A L L I C O N S
    if (child.getAttribute("value") == "smallicons") {
      child.setAttribute("checked", small);
      child.disabled = mode == "text" || lockiconsize;
    }
    // F L E X I B L E   B U T T O N S
    if (child.getAttribute("value") == "flexbuttons") {
      child.setAttribute("checked", flexbuttons);
      // keine flexiblen Buttons in der Tabbar und der Statusleiste.
      child.hidden = isFixedToolbox;
      popup.childNodes[i-1].hidden = isFixedToolbox;
    }
    // F U L L S C R E E N
    if (child.getAttribute("value") == "fullscreentoolbar") {
      child.setAttribute("checked", fullscreentoolbar);
    }
    // P O S I T I O N
    if (child.getAttribute("name") == "position") {
      child.setAttribute("checked", child.getAttribute("value") == position);
      // Hidden for fixed toolboxes (sidebar header), if not customizable, if a
      // fixed toolbar (default toolbars), or vertical positions for tabstoolbar
      // (since vertical tabs are much better done by TabKit).
      child.hidden = isFixedToolbox || !isCustomizableToolbar || isFixedToolbar ||
                     (child.hasAttribute("vertical") && isTabsToolbar);
      // Separator hidden.
      if (child.id == "position1")
        popup.childNodes[i-1].hidden = isFixedToolbox ||
                                       !isCustomizableToolbar ||
                                       (isFixedToolbar && !isTabsToolbar);
                                       
      // Special case for TabsToolbar.
      if ((child.value == "tt-toolbox-abovebrowsertabs" && !isTabsToolbar) ||
          (child.value == "tt-toolbox-abovebrowser" && isTabsToolbar))
       child.hidden = true;
    }
  }
}

/* Change individual toolbar configuration */
function tt_setToolbarMode(evt, aPopup) {
  let toolbar = document.popupNode;
  while (toolbar.localName != "toolbar")
    toolbar = toolbar.parentNode;
  let isTabsToolbar = toolbar.id == "TabsToolbar";
  // All moveable toolbars have a toolbox parentNode.
  let toolbox = toolbar.parentNode;

  let value = evt.originalTarget.value;
  value = (value == "top-toolbox") ? gNavToolbox.id : value;
  let group = evt.originalTarget.getAttribute("name"); // radio group

  if (value == "smallicons") {
    let small = evt.originalTarget.getAttribute("checked") == "true";
    let size = small ? "small" : "large";
    gNavToolbox.setToolbarProperty(toolbar, "iconsize", size);
  }
  else if (value == "fullscreentoolbar") {
    let showInFullScreen = evt.originalTarget.getAttribute("checked") == "true";
    gNavToolbox.setToolbarProperty(toolbar, "fullscreentoolbar", showInFullScreen);
  }
  else if (value == "flexbuttons") {
    let flexbuttons = evt.originalTarget.getAttribute("checked") == "true";
    gNavToolbox.setToolbarProperty(toolbar, "flexbuttons", flexbuttons);
  }
  else if (group == "mode") {
    gNavToolbox.setToolbarProperty(toolbar, "mode", value);
  }
  else if (group == "position") {
    // Special case of TabsToolbar.
    if (isTabsToolbar) {
      tt_setTabsToolbar(value);
    }
    else {
      // We could just remove the <toolbar/> from its current location and
      // append to the desired toolbox, but that would mean we wouldn't
      // respect the rule that custom toolbars appear wherever the
      // <toolbarset/> is.  Also it caused an interesting bug where all
      // the items on the toolbar would be duplicated sometimes after the
      // toolbar was moved.  Finally, we can't just get the currentSet of
      // the existing toolbar and pass it to appendCustomToolbar because
      // currentSet always returns "__empty" during customisation, because
      // all the items are wrapped in extra elements.

      let items = [];
      while (toolbar.hasChildNodes())
        items.push(toolbar.removeChild(toolbar.lastChild));
      let tbarName = toolbar.toolbarName;

      let customIndex = toolbar.getAttribute("customindex");
      if (toolbox.toolbarset.hasAttribute("toolbar"+customIndex)) {
        // Remove regular custom toolbar's toolbarset on the document root.
        toolbox.toolbarset.removeAttribute("toolbar"+customIndex);
        document.persist(toolbox.toolbarset.id, "toolbar"+customIndex);
      }

      toolbox.removeChild(toolbar);

      // Need to now clean up old toolbox: customToolbarCount, remaining
      // toolbar customindexes, toolbarset toolbarX numbering, and
      // persisted values.
      let customCount = 0;
      for (let i = 0; i < toolbox.childNodes.length; ++i) {
        let toolbar = toolbox.childNodes[i];
        if (toolbar.localName == "toolbar" && toolbar.getAttribute("customizable")) {
          // Calculate currentset and store it in the attribute.
          let currentSet = toolbar.currentSet;
          customIndex = toolbar.getAttribute("customindex");
          if (customIndex) {
            // Reindex custom toolbar info on the <toolbarset/>.
            if (toolbox.toolbarset.hasAttribute("toolbar"+customIndex)) {
              toolbox.toolbarset.removeAttribute("toolbar"+customIndex);
              document.persist(toolbox.toolbarset.id, "toolbar"+customIndex);
            }
            toolbox.toolbarset.setAttribute("toolbar" + (++customCount),
                toolbar.toolbarName + ":" + currentSet);
            toolbar.setAttribute("customindex", customCount); //adjust count
            document.persist(toolbox.toolbarset.id, "toolbar" + customCount);
          }
        }
      }
      // Number of remaining toolbars.
      toolbox.customToolbarCount = customCount;
      if (customCount == 0 && toolbox.id != "navigator-toolbox")
        // None..
        toolbox.setAttribute("empty", true);

      // Remove toolbarX attributes from toolbarset or xul doc root for removed
      // toolbars, ie any entries past those for toolbars already indexed..
      while (toolbox.toolbarset.hasAttribute("toolbar" + (++customCount))) {
        toolbox.toolbarset.removeAttribute("toolbar" + customCount);
        document.persist(toolbox.toolbarset.id, "toolbar" + customCount);
      }

      // Recreate externalToolbars list if moving a toolbar and remove it;
      // if it's added to a non navToolbox toolbox then the constructor will add
      // it back to the list upon append.
      let newExternalToolbars = [];
      toolbar.removeAttribute("toolboxid");
      gNavToolbox.externalToolbars.forEach(function (extToolbar, index) {
        if (extToolbar.id != toolbar.id)
          newExternalToolbars.push(extToolbar);
      })
      gNavToolbox.externalToolbars = newExternalToolbars;

      // Create new toolbar.
      let newToolbox = document.getElementById(value);
      let newToolbar = newToolbox.appendCustomToolbar(tbarName, "__empty", true);
      while (items.length)
        newToolbar.appendChild(items.pop());

      toolbox = newToolbox;
      toolbar = newToolbar;
      // Retain options.
      handleOptions("copy", toolbar, gNavToolbox);
      // Calculate currentset and store it in the attribute.
      let currentSet = toolbar.currentSet;
      customIndex = toolbar.getAttribute("customindex");
      toolbar.setAttribute("currentset", currentSet);
      toolbox.removeAttribute("empty");

      // Persist custom toolbar info on the <toolbarset/>.
      toolbox.toolbarset.setAttribute("toolbar" + customIndex,
          toolbar.toolbarName + ":" + currentSet);
      document.persist(toolbox.toolbarset.id, "toolbar" + customIndex);
    }
  }

  tt_adjustToolboxWidth(aPopup);
}

/* Set or unset fixed width for vertical toolbars */
function tt_adjustToolboxWidth(fix) {
  // Aufruf durch Drag-Event der Toolbox.
  if (typeof fix == "object") {
    fix = false;
    window.setTimeout(function() { tt_adjustToolboxWidth(true) }, 200);
  }

  let computedStyle, myWidth;
  let vToolboxes = document.getElementsByAttribute("vertical", "true");

  for (let i = 0; i < vToolboxes.length; i++) {
    if (vToolboxes[i].tagName == "toolbox") {
      myWidth = 0;
      // Set fixed width.
      if (fix) {
        let boxChilds = vToolboxes[i].childNodes;
        // Add up width of all toolbars in the toolbox.
        for (let j = 0; j < boxChilds.length; j++) {
          if (boxChilds[j].tagName == "toolbar") {
            computedStyle = document.defaultView.getComputedStyle(boxChilds[j], null);
            myWidth = myWidth + parseInt(computedStyle.width);
            myWidth = myWidth + parseInt(computedStyle.paddingLeft);
            myWidth = myWidth + parseInt(computedStyle.paddingRight);
            myWidth = myWidth + parseInt(computedStyle.marginLeft);
            myWidth = myWidth + parseInt(computedStyle.marginRight);
            myWidth = myWidth + parseInt(computedStyle.borderLeftWidth);
            myWidth = myWidth + parseInt(computedStyle.borderRightWidth);
          }
        }

        vToolboxes[i].style.maxWidth = myWidth + "px";
      }
      // Unset width.
      else {
        vToolboxes[i].removeAttribute("width");
        vToolboxes[i].removeAttribute("style");
      }
    }
  }

  return true;
}

/* Clean up options from root doc for removed or empty toolbars */
function handleOptions(aType, toolbar, aNavToolbox) {
  if (toolbar.localName != "toolbar")
    return;
  let attr = "_toolbar." + toolbar.id + ".";
  let toolbarOptions = ["mode",
                        "iconsize",
                        "fullscreentoolbar",
                        "flexbuttons",
                        "collapsed"];

  var docElt = aNavToolbox.ownerDocument.documentElement;

  toolbarOptions.forEach(function(option) {
    if (docElt.hasAttribute(attr + option)) {
      if (aType == "remove") {
        if (toolbar.hasAttribute(option)) {
        // Remove global iconsize/mode options.
//debugTT("remove from toolbar: "+toolbar.id+" : "+option);
          toolbar.removeAttribute(option);
        }
      // Remove customtoolbar options.
//debugTT("remove from doc: "+docElt.id+" : "+attr + option);
        docElt.removeAttribute(attr + option);
        aNavToolbox.ownerDocument.persist(docElt.id, attr + option);
      }
      if (aType == "copy") {
        let val = docElt.getAttribute(attr + option);
        toolbar.setAttribute(option, val);
      }
    }
  });
}

/* Show or hide toolbars in fullscreen mode */
function tt_BrowserFullScreen() {
  let toolboxes = [];
  // Get all vertical toolboxes in the array.
  let vToolboxes = document.getElementsByAttribute("vertical", "true");
  for (let i = 0; i < vToolboxes.length; i++) {
    if (vToolboxes[i].tagName == "toolbox") toolboxes.push(vToolboxes[i]);
  }

  // Toolboxen durchlaufen.
  for (let i = 0; i < toolboxes.length; i++) {
    let boxChilds = toolboxes[i].childNodes;
    let fsChilds = 0;

    // Child-Elemente durchlaufen (Toolbars).
    for (let j = 0; j < boxChilds.length; j++) {
      if (boxChilds[j].getAttribute("fullscreentoolbar") == "true")
        fsChilds++;
    }

    // If all toolbars hidden, make toolbox also hidden.
    if (window.fullScreen)
      toolboxes[i].setAttribute("hidden", !(fsChilds > 0));
    else
      toolboxes[i].setAttribute("hidden", false);
  }
}

/* Console logger */
function debugTT(aMsg) {
  Components.classes["@mozilla.org/consoleservice;1"].
                    getService(Components.interfaces.nsIConsoleService).
                    logStringMessage("TotalToolbar::" +
                                     arguments.callee.caller.name + ": " +
                                     aMsg);
}

//******************************************************************************
// Customizations of browser.js functions.
//******************************************************************************

function onViewToolbarsPopupShowing(aEvent, aInsertPoint) {
  var popup = aEvent.target;
  if (popup != aEvent.currentTarget)
    return;

  // Empty the menu
  for (var i = popup.childNodes.length-1; i >= 0; --i) {
    var deadItem = popup.childNodes[i];
    if (deadItem.hasAttribute("toolbarId"))
      popup.removeChild(deadItem);
  }

   var firstMenuItem = aInsertPoint || popup.firstChild;

  let toolbarNodes = Array.slice(gNavToolbox.childNodes);
  toolbarNodes = toolbarNodes.concat(gNavToolbox.externalToolbars); //!!
  toolbarNodes.forEach(function(toolbar) {
    var toolbarName = toolbar.getAttribute("toolbarname");
    if (toolbarName) {
      let menuItem = document.createElement("menuitem");
      let hidingAttribute = toolbar.getAttribute("type") == "menubar" ?
                            "autohide" : "collapsed";
      menuItem.setAttribute("id", "toggle_" + toolbar.id);
      menuItem.setAttribute("toolbarId", toolbar.id);
      menuItem.setAttribute("type", "checkbox");
      menuItem.setAttribute("label", toolbarName);
      menuItem.setAttribute("checked", toolbar.getAttribute(hidingAttribute) != "true");
      if (popup.id != "appmenu_customizeMenu")
        menuItem.setAttribute("accesskey", toolbar.getAttribute("accesskey"));
      popup.insertBefore(menuItem, firstMenuItem);

      menuItem.addEventListener("command", onViewToolbarCommand, false);
    }
  }, this);
}

/* Handle and persist collapsed state of custom toolbars, not just fixed ones. */
function onViewToolbarCommand(aEvent) {
  let toolbarId = aEvent.originalTarget.getAttribute("toolbarId");
  let toolbar = document.getElementById(toolbarId);
  let isVisible = aEvent.originalTarget.getAttribute("checked") == "true";

  if (toolbar.hasAttribute("customindex"))
    // Custom toolbars need collapsed state persisted on the document.
    gNavToolbox.setToolbarProperty(toolbar, "collapsed", !isVisible);
  else
    setToolbarVisibility(toolbar, isVisible);

  tt_adjustToolboxWidth(true);
}
